import urllib3
import json
from datetime import datetime

try:
    from __main__ import _NOW__
except:
    _NOW__ = ''


class Api_agent():

    def __init__(self, portfolioDataPath="", assetClassPath=''):
        if portfolioDataPath == "":
            portfolioDataPath = 'test_data/portfolio.json'
        if assetClassPath == "":
            assetClassPath = 'test_data/class.json'
        self.__DEBUG_INFO = ""
        self.__classdata = json.load(open(assetClassPath, encoding='utf8'))
        if type(portfolioDataPath) == str:
            self.__portfolioData  = json.load(open(portfolioDataPath, encoding='utf8'))
        else: 
            self.__portfolioData  = json.load(open(portfolioDataPath[0], encoding='utf8'))
            if portfolioDataPath[1] != "":
                self.__portfolioData_record  = json.load(open(portfolioDataPath[1], encoding='utf8'))
            
        self.__portfolios = {}
        self.__rp_idPortfolios = {}
        self.today = datetime.now().strftime("%Y%m%d")
        if _NOW__ != '':
            self.today = _NOW__
            print(f"日期非採用系統時間 ，採用傳入時間{self.today}")
    '''    
    def __get_request(self, query_string):
        try:
            rel = self.__TV_API.request("GET", query_string, headers = self.__HEADER_VALUES)
            if rel == None:
                pe
                return None
            data = ""
            data = json.loads(rel.data.decode('utf-8'))
            if len(data['data']) == 0:
                return None
            return data
        except Exception as e:
            self.__DEBUG_INFO = str(e)
            return None
    '''
    def get_debug_info(self):
        return self.__DEBUG_INFO

    def get_latest_portfolio(self, portfolio_id, query_date):
        query_date = query_date.replace('-','')
        if query_date != '' and query_date != self.today:
            self.__DEBUG_INFO = ('目前不提供指定日期取得推薦功能，除非是本日(%s)，實際輸入日期為(%s)' %(self.today,query_date ))
            #print("測試時忽略推薦日期檢查")
            print("***  測試時間不同，可能是 {vender}_quant_api.py 未加入 replace datetime.now()的程式碼")
            return None
        if portfolio_id in self.__portfolios.keys():
            return self.__portfolios[portfolio_id]

        try:
            data = self.__portfolioData
            if len(data['rps']) == 0:
                return None

            for d in data['rps'] :
                if d['recomm_guid'] == portfolio_id:
                    if not 'data_Date' in d:
                        print(" Warning: `data_Date` is None, 但是不影響測試，只影響生產環境")
                    elif  d['data_Date'] == self.today :
                        pass
                    else: 
                        print(" Warning: `data_Date` is invalidated, 但是不影響測試，只影響生產環境")
                        
                    self.__portfolios[portfolio_id] = d
                    return self.__portfolios[portfolio_id]
                    

            return None
        except Exception as e:
            self.__DEBUG_INFO = str(e)
            return None
        pass

        api_query = "%s/franklin/prediction_data/%s/%s" % (self.__TV_API_URL, portfolio_id, query_date)
        return self.__get_request(api_query)

    def get_portfolio_by_rpid(self, rp_id):
        rp_id = str(rp_id)
        if rp_id in self.__rp_idPortfolios.keys():
            return self.__rp_idPortfolios[rp_id]

        try:
            data = self.__portfolioData_record
            if len(data['rps']) == 0:
                return None

            for d in data['rps'] :
                d['rp_id'] = str(d['rp_id'])
                if d['rp_id'] == rp_id:
                    self.__rp_idPortfolios[rp_id] = d
                    return self.__rp_idPortfolios[rp_id]

            return None
        except Exception as e:
            self.__DEBUG_INFO = str(e)
            return None
        pass

        api_query = "%s/franklin/prediction_data/%s/%s" % (self.__TV_API_URL, portfolio_id, query_date)
        return self.__get_request(api_query)

    def get_fund_metadata(self, fund_id):
        return self.__classdata[fund_id]
        pass

        api_query = "%s/franklin/fundpool/%s" % (self.__TV_API_URL, fund_code)
        data = self.__get_request(api_query)
        if not data == None:
            return data['data'][0]
        return None
